define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var Model = function() {
		this.callParent();
		this.timer;
		this.minute;
		this.second;
	};
	/** 分享到微信朋友圈 */
	Model.prototype.pengyouquanClick = function(event) {
		function success(result) {
			alert(JSON.stringify(result));
		}
		function error(result) {
			alert(JSON.stringify(result));
		}
		navigator.weixin.share({
			message : {
				title : "WeX5开发指南",
				description : "分享到微信",
				mediaTagName : "Media Tag Name(optional)",
				thumb : "http://YOUR_THUMBNAIL_IMAGE",
				media : {
					// type: weixin.Type.WEBPAGE, // webpage
					webpageUrl : window.location.href
				// webpage
				}
			},
			scene : navigator.weixin.Scene.TIMELINE
		}, success, error);
	};

	Model.prototype.getTotalTime = function(fAnswerMasterID) {
		var totalTime = "";
		var params = new biz.Request.ActionParam();
		params.setString("fAnswerMasterID", fAnswerMasterID);
		// 调用动作
		biz.Request.sendBizRequest({
			"dataType" : "json",
			"context" : this.getContext(),
			"action" : "getTotalTime",
			"parameters" : params,
			"callback" : function(data) {
				// debugger;
				data.ignoreError = false;
				if (data.state) {
					totalTime = data.response.rows[0].fTotalTime.value;
				}
			}

		});
		return totalTime;
	}
	/** 倒计时 */
	Model.prototype.countDown = function(intDiff) {
		var self = this;
		timer = window.setInterval(function(event) {
			var minute = 0, second = 0;// 时间默认值
			if (intDiff >= 0) {
				minute = Math.floor(intDiff / 60);
				second = Math.floor(intDiff % 60);
				if (intDiff == 5 * 60)
					justep.Util.hint("请注意，还有5分钟!");
				--intDiff;
			} else {// 当时间耗尽，交卷
				justep.Util.hint("答题时间到，系统将在5秒后自动交卷", {
					"type" : "info",
					"delay" : 3000
				});
				setTimeout(self.messageDialog2Yes(event), 5000);

			}
			if (minute <= 9)
				minute = '0' + minute;
			if (second <= 9)
				second = '0' + second;
			$("[xid='span10']").html('<font>' + minute + ":" + second + '</font>');

		}, 1000);

	};

	Model.prototype.modelLoad = function(event) {
		// debugger;
		var answerData = this.comp("answerData");
		var answerDetail = this.comp("answerDetail");

		var fpersonID = this.getContext().getCurrentPersonID();
		var answerMaster = this.comp("answerMaster");
		answerMaster.setFilter("myFilter", "TE_AnswerMaster.fAnswerPersonID='" + fpersonID + "'");
		answerMaster.refreshData();

		answerDetail.setFilter("filter", "TE_AnswerDetail.fAnswerPersonID='" + fpersonID + "'");
		answerDetail.refreshData();
		// debugger;
		var fAnswerMasterID = answerMaster.getCurrentRowID();
		minute = this.getTotalTime(fAnswerMasterID);
		minute = parseInt(minute);
		var fID = answerDetail.getCurrentRowID();
		var fPaperTopicID = answerDetail.getValueByID("fPaperTopicID", fPaperTopicID, fID);

		if (answerMaster.getValueByID("fPaperState", fAnswerMasterID) == "已交卷") {
			this.comp("next").set({
				"disabled" : false
			});
		} else {
			this.comp("next").set({
				"disabled" : true
			});
		}

		this.comp("submitBtn").set({
			"disabled" : true
		});

		var arr = this.getAnswer(fPaperTopicID);

		for (var j = 0; j < arr.length; j++) {
			answerData.newData();
			answerData.setValue("fID", arr[j].fID.value);
			answerData.setValue("answer", arr[j].fAnswer.value);

		}
	};

	/** 调用获取正确答案的动作 */
	Model.prototype.getCorrectAnswer = function(fPaperTopicID) {
		var correctAnswer = new Array();
		var params = new biz.Request.ActionParam();
		params.setString("fMasterID", fPaperTopicID);
		// 调用动作
		biz.Request.sendBizRequest({
			"dataType" : "json",
			"context" : this.getContext(),
			"action" : "getCorrectAnswer",
			"parameters" : params,
			"callback" : function(data) {
				// debugger;
				data.ignoreError = false;
				if (data.state) {
					if (data.response.rows.length != 0) {
						correctAnswer = data.response.rows;
					}
				}
			}
		});
		return correctAnswer;
	};

	Model.prototype.getAnswer = function(fPaperTopicID) {
		var arr = new Array();
		var params = new biz.Request.ActionParam();
		params.setString("fPaperTopicID", fPaperTopicID);
		// 调用动作
		biz.Request.sendBizRequest({
			"dataType" : "json",
			"context" : this.getContext(),
			"action" : "getAnswer",
			"parameters" : params,
			"callback" : function(data) {
				// debugger;
				data.ignoreError = false;
				if (data.state) {
					arr = data.response.rows;
				}
			}

		});
		return arr;
	};

	Model.prototype.beginAnswerClick = function() {
		second = new Number(60);
		var intDiff = parseInt(minute * second);// 倒计时总秒数量
		this.countDown(intDiff);
		 this.comp("next").set({
		 "disabled" : false
		 });
		 this.comp("submitBtn").set({
		 "disabled" : false
		 });
		 this.comp("pre").set({
		 "disabled" : false
		 });

	};

	/** 交卷按钮点击事件 */
	Model.prototype.submitBtnClick = function() {
		var answerDetail = this.comp("answerDetail");
		// 获取data的最后一行，没有数据时返回null
		var lastRow = answerDetail.getLastRow();
		var lastRowID = lastRow.row.TE_AnswerDetail.value.latestValue;
		var fID = answerDetail.getCurrentRowID();
		if (fID == lastRowID) {
			this.comp("messageDialog2").show({
				title : "您确定要交卷吗？"
			});
		} else {
			this.comp("messageDialog2").show({
				title : "题还没有答完哦！您确定要交卷吗？"
			});
		}

	};
	/** 获得各种题型的回答正确的数量 */
	Model.prototype.getCorrectAnswerNumber = function(fPersonID) {
		var array = new Array();
		var params = new biz.Request.ActionParam();
		params.setString("fPersonID", fPersonID);
		// 调用动作
		biz.Request.sendBizRequest({
			"dataType" : "json",
			"context" : this.getContext(),
			"action" : "getCorrectAnswerNumber",
			"parameters" : params,
			"callback" : function(data) {
				// debugger;
				if (data.state) {
					array = data.response.rows;
				}
			}

		});
		return array;
	};
	/** 获得各种题型的分值 */
	Model.prototype.getTopicScore = function(fPaperID) {
		var array = new Array();
		var params = new biz.Request.ActionParam();
		params.setString("fPaperID", fPaperID);
		// 调用动作
		biz.Request.sendBizRequest({
			"dataType" : "json",
			"context" : this.getContext(),
			"action" : "getTopicScore",
			"parameters" : params,
			"callback" : function(data) {
				// debugger;
				if (data.state) {
					array = data.response.rows;
				}
			}

		});
		return array;
	};

	/** 点击Yes按钮，关闭对话框时触发事件 */
	Model.prototype.messageDialog2Yes = function(event) {
		// debugger;
		var answerDetail = this.comp("answerDetail")
		answerDetail.saveData();
		clearTimeout(timer);
		// debugger;
		var fpersonID = this.getContext().getCurrentPersonID();
		var answerMaster = this.comp("answerMaster");
		answerMaster.setFilter("myFilter", "TE_AnswerMaster.fAnswerPersonID='" + fpersonID + "'");
		answerMaster.refreshData();
		var fAnswerMasterID = answerMaster.getCurrentRowID();
		var maxTime = this.getTotalTime(fAnswerMasterID);
		maxTime = (parseInt(maxTime) - 1);
		maxTime = maxTime + "*59";
		var maxTimeArr = maxTime.split("*");

		var span10 = $("[xid='span10']").text();
		var span10Arr = span10.split(":");
		var minute = parseInt(maxTimeArr[0]) - parseInt(span10Arr[0]);
		var second = parseInt(maxTimeArr[1]) - parseInt(span10Arr[1]);
		if (parseInt(second) < 10)
			second = "0" + second;
		var useTime = minute + "分" + second + "秒";
		var paper = this.comp("paper");
		var answerMaster = this.comp("answerMaster");
		var fID = answerMaster.getCurrentRowID();
		var fPersonID = this.getContext().getCurrentPersonID();
		var fPaperID = paper.getCurrentRowID();
		// 获得各种题型得分值，查的数据库
		var arrScore = this.getTopicScore(fPaperID);
		// 获得正确答案的数量，查的数据库
		var arrNumber = this.getCorrectAnswerNumber(fPersonID);
		var fSingleNumber = parseInt(arrNumber[0].fSingleNumber.value);
		var fMultiNumber = parseInt(arrNumber[0].fMultiNumber.value);
		var fCheckNumber = parseInt(arrNumber[0].fCheckNumber.value);
		var fCompleteNumber = parseInt(arrNumber[0].fCompleteNumber.value);
		var fJQuizNumber = parseInt(arrNumber[0].fJQuizNumber.value);
		// var fChoseAnswer=answerDetail.getValueByID("fChoseAnswer",
		// answerDetail.getCurrentRowID());

		var totalNumber = fSingleNumber + fMultiNumber + fCheckNumber + fCompleteNumber + fJQuizNumber;

		var singleScore = arrScore[0].fSingleScore.value * fSingleNumber;
		var multiScore = arrScore[0].fMultiScore.value * fMultiNumber;
		var checkScore = arrScore[0].fCheckScore.value * fCheckNumber;
		var completeScore = arrScore[0].fCompleteScore.value * fCompleteNumber;
		// 填空题分值
		var JQuizScore = arrScore[0].fJQuizScore.value * fJQuizNumber;

		var totalScore = singleScore + multiScore + checkScore + completeScore + JQuizScore;
		answerMaster.setValueByID("fPaperState", "已交卷", fID);
		answerMaster.setValueByID("fTotalScore", totalScore, fID);
		answerMaster.setValueByID("fUseTime", useTime, fID);
		answerMaster.saveData();
		$("[xid='score']").val(totalScore);
		$("[xid='number']").val(totalNumber);
		this.comp("popOver1").show();

	};

	/** 数据发生变化（包括新增、刷新、删除、修改引起的变化），感知从data的变化 */
	Model.prototype.answerMasterDataChange = function(event) {
		// debugger;
		var answerDetail = this.comp("answerDetail");
		var fTopicOrder = answerDetail.getValue("fTopicOrder");
		$("[xid='current']").val(fTopicOrder);
		var total = this.comp("topicOrderList").getData().getCount();
		$("[xid='total']").val(total);
	};
	/** 下一题按钮点击事件 */
	Model.prototype.nextClick = function(event) {
		// debugger;
		var answerData = this.comp("answerData");
		var answerDetail = this.comp("answerDetail");
		var fID = answerDetail.getCurrentRowID();
		var fPaperTopicID = answerDetail.getValueByID("fPaperTopicID", fPaperTopicID, fID);
		var arr = this.getAnswer(fPaperTopicID);
		// 清空数据
		answerData.clear();
		for (var j = 0; j < arr.length; j++) {
			answerData.newData();
			answerData.setValue("fID", arr[j].fID.value);
			answerData.setValue("answer", arr[j].fAnswer.value);

		}

	};

	Model.prototype.preClick = function(event) {
		var answerData = this.comp("answerData");
		var answerDetail = this.comp("answerDetail");
		var fID = answerDetail.getCurrentRowID();
		var fPaperTopicID = answerDetail.getValueByID("fPaperTopicID", fPaperTopicID, fID);
		var arr = this.getAnswer(fPaperTopicID);
		// 清空数据
		answerData.clear();
		for (var j = 0; j < arr.length; j++) {
			answerData.newData();
			answerData.setValue("fID", arr[j].fID.value);
			answerData.setValue("answer", arr[j].fAnswer.value);

		}

	};

	Model.prototype.radioGroup2Change = function(event) {
		// debugger;
		var choseAnswer = event.value;
		var answerDetail = this.comp("answerDetail");
		var fID = answerDetail.getCurrentRowID();
		answerDetail.setValueByID("fChoseAnswer", choseAnswer, fID);
		answerDetail.saveData();
	};
	Model.prototype.checkboxGroup1Change = function(event) {
		// debugger;
		var choseAnswer = event.value;
		var answerDetail = this.comp("answerDetail");
		var fID = answerDetail.getCurrentRowID();
		answerDetail.setValueByID("fChoseAnswer", choseAnswer, fID);
		answerDetail.saveData();
	};
	Model.prototype.orderDivClick = function(event) {
		var answerMaster = this.comp("answerMaster");
		var fID = answerMaster.getCurrentRowID();
		var fPaperState = answerMaster.getValueByID("fPaperState", fID);
		if (fPaperState == "未交卷") {
			$("[xid='orderDiv1']").toggle(1000);
		} else {
			$("[xid='orderDiv2']").toggle(1000);
		}
	};

	Model.prototype.answerDataValueChanged = function(event) {
		 //debugger;
		var correctAnswers = "";
		var answerDetail = this.comp("answerDetail");
		var fID = answerDetail.getCurrentRowID();
		var fPaperTopicID = answerDetail.getValueByID("fPaperTopicID", fID);
		var correctAnswer = this.getCorrectAnswer(fPaperTopicID);
		for (var i = 0; i < correctAnswer.length; i++) {
			if (i == correctAnswer.length - 1) {
				correctAnswers += correctAnswer[i].fAnswer.value;
			} else {
				correctAnswers += correctAnswer[i].fAnswer.value + " ";
			}

		}
		answerDetail.setValueByID("fCorrectAnswer", correctAnswers, fID);
		answerDetail.saveData();
	};
	/** 未考按钮点击事件 */
	Model.prototype.button3Click = function(event) {
		var answerMaster = this.comp("answerMaster");
		answerMaster.setFilter("filter", "TE_AnswerMaster.fPaperState='未交卷'");
		answerMaster.refreshData();
	};
	/** 已考按钮点击事件 */
	Model.prototype.button4Click = function(event) {
		var answerMaster = this.comp("answerMaster");
		answerMaster.setFilter("filter", "TE_AnswerMaster.fPaperState='已交卷'");
		answerMaster.refreshData();
	};
	Model.prototype.countdown = function(intDiff) {
		debugger;

	};
	Model.prototype.div12Click = function(event) {
		// debugger;
		var me = this;
		this.comp("popOver2").show();
		var num = 4;
		var min = 0;
		function decreaseNum() {
			// debugger;
			--num;
			if (num == min) {

				me.comp("popOver2").hide();
				me.comp("contents1").to("topicContent");
				me.beginAnswerClick();
			} else {
				setTimeout(decreaseNum, 1000);
				$("[xid='div14']").text(num);
			}

		}
		setTimeout(decreaseNum, 1000);
	};

	Model.prototype.row1Click = function(event) {
	//debugger;
		var answerMaster = this.comp("answerMaster");
		var fPaperState = answerMaster.getValue("fPaperState");
		if (fPaperState == "未交卷") {
			this.comp("contents1").to("answerContent");
		} else {
			this.comp("contents1").to("topicContent");
		}

	};

	return Model;
});
define(function(require){
	var $ = require("jquery");
	var Model = function(){
		this.callParent();
	};
	Model.prototype.nextClick = function(event){

	};

	return Model;
});
